/*   HelloWin.c   */

#include <windows.h>
#include <stdio.h>  /*enthaelt sprintf()*/

#pragma warning(disable : 4996) // ("veraltet")

#define MIT_TEXTOUT  /* evtl. auskommentieren! */
#define MIT_WM_CHAR  /* evtl. auskommentieren! */
#define MIT_KEYDOWN  /* evtl. auskommentieren! */

#ifndef MIT_TEXTOUT
#undef  MIT_WM_CHAR
#undef  MIT_KEYDOWN
#endif  MIT_TEXTOUT

/* Vorausdeklaration von WndProc: */
LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);

/* *********************************************************************** */
   int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                       PSTR      szCmdLine, int       iCmdShow)
/* *********************************************************************** */
{ static TCHAR    szAppName[]=TEXT("HelloWin");
         HWND     hwnd;
         MSG      msg;
         WNDCLASS wndclass;

  /* Festlegung der Fensterklasse: */
  wndclass.style         = CS_HREDRAW|CS_VREDRAW;          /* neu zeichnen */
  wndclass.lpfnWndProc   = WndProc;         /* Fenster-Prozedur(Callback)  */
  wndclass.cbClsExtra    = 0;               /* Zusatzspeicher-Reservierung */
  wndclass.cbWndExtra    = 0;               /* Zusatzspeicher-Reservierung */
  wndclass.hInstance     = hInstance;          /* (aus WinMain-Par.-Liste) */
  wndclass.hIcon         = LoadIcon(NULL,IDI_APPLICATION);  /* Stndrd-Icon */
  wndclass.hCursor       = LoadCursor(NULL,IDC_ARROW); /* Std.-PfeilCursor */
  wndclass.hbrBackground =(HBRUSH)GetStockObject(WHITE_BRUSH);    /* weiss */
  wndclass.lpszMenuName  = NULL;                             /* ohne Menue */
  wndclass.lpszClassName = szAppName;          /* Fensterklasse "HelloWin" */

  /* Registrierung der Fensterklasse: */ 
  RegisterClass(&wndclass);            /* Initialisierte wndclass=Standard */
  
  /* Initialisierung der Anwendung: */
  hwnd = CreateWindow (szAppName,           /* registrierter Fenster-Name, */
                       TEXT("SysProg goes Windows"),  /* Fenster-Titel,    */
                       WS_OVERLAPPEDWINDOW, 		  /* Stil,             */
                       CW_USEDEFAULT,                 /* x-Pos.,           */
                       CW_USEDEFAULT,                 /* y-Pos.,           */
                       300,                 /*auch: CW_USEDEFAULT: Breite, */
                       100,                 /*auch: CW_USEDEFAULT: Hoehe,  */
                       NULL,                          /* Eltern-Fenster,   */
                       NULL,                          /* Menue,            */
                       hInstance,                     /* Programm-ID,      */
                       NULL);                         /* weitere Parameter */
  ShowWindow (hwnd, iCmdShow);                        /* Titelleiste,Rahmen*/
  UpdateWindow (hwnd);			                      /* Fenster fuellen   */

  /* Nachrichtenschleife: */
  while(GetMessage(&msg,NULL,0,0))          /* Solange Nachricht != WM_QUIT*/
  { TranslateMessage(&msg);	 	            /* ..interpretieren..          */
    DispatchMessage (&msg);	 	            /* ..u.Callback uebergeben     */
  }
  return msg.wParam;		                /* Parameter der Beendigung    */
}

#ifdef  MIT_TEXTOUT
/* *********************************************************************** */
   LRESULT CALLBACK WndProc (HWND hwnd, UINT message, WPARAM wParam,
                                                       LPARAM lParam)
/* *********************************************************************** */
{ HDC         hdc;         /* Geraetekennung          */
  PAINTSTRUCT ps;          /* Art der Zeichenvorgangs */
  RECT        rect;        /* Zeichenflaeche          */

  int   iLength=1;                    /*Anzahl Zeichen*/
#ifdef MIT_WM_CHAR
  static TCHAR szBuffer[2]; /*Speicher ohne glob. Var.*/
#else  // MIT_WM_CHAR
  TCHAR szBuffer [40];               /*String-Speicher*/
#endif // MIT_WM_CHAR
  TEXTMETRIC tm;
  static int cxChar, cyChar;  /*Vermeidg globaler Var.*/	

  switch (message)
  { case WM_CREATE: /*Einstellungen einmalig,zu Beginn*/
         hdc = GetDC (hwnd);
         GetTextMetrics(hdc, &tm);   /*Schrift-Abfrage*/
         cxChar = tm.tmAveCharWidth;/*count x y: Pixel*/
         cyChar = tm.tmHeight + tm.tmExternalLeading;
         ReleaseDC (hwnd, hdc);
         return 0;

    case WM_PAINT:                     /*Fenster neufuellen:*/
         hdc=BeginPaint (hwnd, &ps);   /*Fenster loeschen   */
////     hdc = GetDC (hwnd); //flimmert (s. Vorl.-Folien)
         GetClientRect  (hwnd, &rect); /*Flaeche ermitteln  */

#ifdef  MIT_WM_CHAR
#else   //MIT_WM_CHAR
      	 iLength=sprintf(szBuffer,TEXT("HelloWin, %dx mit TextOut!"), 1);
#endif  //MIT_WM_CHAR
	       TextOut (hdc, 2*cxChar, cyChar, szBuffer, iLength);
////     ReleaseDC (hwnd, hdc); //flimmert
         EndPaint (hwnd, &ps);		     /* Geraet-Freigabe   */
         return 0;

    case WM_DESTROY:  /*Ctrl-F4,Alt-F4,[x]-Klick,Systemmenue*/
         PostQuitMessage(0);/*setzt WM_QUIT in Warteschlange*/
         return 0;

#ifdef  MIT_KEYDOWN
    case WM_KEYDOWN: // ebenso gut: case WM_CHAR:
         switch (wParam)
         { case VK_ESCAPE:                        /* escape */
           SendMessage (hwnd, WM_DESTROY, 0, 0);
//ebenso:  SendMessage (hwnd, WM_CLOSE, 0, 0);
//           SendMessage (hwnd, WM_QUIT, 0, 0);/*wirkungslos*/
           break; 
         }
#endif  //MIT_KEYDOWN

#ifdef  MIT_WM_CHAR
    case WM_CHAR:
         switch (wParam)
         {
           case '\b':                 /*(...)      backspace*/
                break;
           default:                   /*(...)character codes*/
      	        iLength=sprintf(szBuffer, TEXT("%c"), (TCHAR)wParam);
                InvalidateRect (hwnd, NULL, TRUE);
                break;
         }
#endif  //MIT_WM_CHAR
  }
  return DefWindowProc(hwnd,message,wParam,lParam);     /*sonstiges*/
}						

#else  // MIT_TEXTOUT

/* *********************************************************************** */
   LRESULT CALLBACK WndProc (HWND hwnd, UINT message, WPARAM wParam,
                                                       LPARAM lParam)
/* *********************************************************************** */
{ HDC         hdc;   /* Geraetekennung          */
  PAINTSTRUCT ps;    /* Art der Zeichenvorgangs */
  RECT        rect;  /* Zeichenflaeche          */

  switch (message)
  { case WM_PAINT:                               /* Fenster neufuellen:    */
         hdc=BeginPaint (hwnd, &ps);             /* Fenster loeschen       */
         GetClientRect  (hwnd, &rect);           /* Flaeche ermitteln      */
         DrawText (hdc,                          /* Geraetekennung         */
                   TEXT("Hello, Windows!"),      /* Ausgabe-Text           */
                   -1,                           /* string terminated by 0 */
                   &rect,                        /* Zeichenflaeche         */
                   DT_SINGLELINE|DT_CENTER|DT_VCENTER);/* DrawText-Options */
         EndPaint (hwnd, &ps);		                     /* Geraet-Freigabe  */
         return 0;

    case WM_DESTROY:               /* Ctrl-F4,Alt-F4,[x]-Klick,Systemmenue */
         PostQuitMessage(0);       /* setzt WM_QUIT in Warteschlange       */
         return 0;
  }
  return DefWindowProc(hwnd,message,wParam,lParam);           /* sonstiges */
}						
#endif // MIT_TEXTOUT
